import unittest, os

from pynumad.objects.airfoil import Airfoil

test_data_dir = os.path.join(os.path.dirname(__file__), "test_data")


class TestAirfoil(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        cls.xmlfile = os.path.join(test_data_dir, "airfoils", "DU91-W-250.txt")

    def test_load_xml(self):
        x = Airfoil(filename=self.xmlfile)

        # check reference
        self.assertEqual(x.reference, "Points generated by BRR for NuMAD, 6/2/2011")

        # TODO: check coords


if __name__ == "__main__":
    unittest.main()
